<?php

//Config values
$includedir='./prgmdata/'; //A modifier aussi dans config.inc.php et index.php
define('IN_PARTAGE',true);
$nitem=30;
include($includedir.'Partage.inc.php');

$partage=new Partage;

$rss='';
$rss.='<?xml version="1.0" encoding="utf-8" ?>'."\n";
/*$rss.="<?xml-stylesheet type=\"text/xsl\" href=\"./stylerss.css\" media=\"screen\" ?>\n";*/
$rss.='<rss version="2.0">
<channel>
	<title>Serveur de partage de example.com</title>
	<link>'.$partage->get_root_url().'index.php</link>
	<description>Fichiers mis à jour sur le serveur de partage</description>
	<language>fr</language>
	<copyright>example.com</copyright>
	<generator>Service de partage de http://example.com</generator>
	<lastBuildDate>'.date('r').'</lastBuildDate>
	<ttl>360</ttl>
';
$rss.='	<image>
		<title>Logo</title>
		<link>http://www.example.com/</link>
		<url>./img/logo.png</url>
';
/*$rss="		<width>undefined</width>
		<height>undefined</height>
";*/
$rss.='	</image>
';

$rss.="\r\n";

// Berk, berk, berk
$dirs[0]['path'] = $partage->get_root();
for ($a=0; $a<sizeof($dirs); $a++)
	$dirs = array_merge($dirs, $partage->ls_dir($dirs[$a]['path'], LIST_DIRECTORIES, INFOS_PATH));

$files=Array();
foreach ($dirs as $dir)
{
	$allfiles = $partage->ls_dir($dir['path'], LIST_FILES);

	foreach ($allfiles as $file)
	{
		//clearstatcache();
		$timestamp = filemtime($file['path']);	//Normalement, on n'a pas put avoir dans $dirs de dossiers au dessus de la racine, donc on ne fait pas de vérifications supplémentaires

		while (isset($files[$timestamp]))    //On parie bien sûr sur la très forte improbabilité d'avoir deux timestamp égaux !
			$timestamp++;

		$files[$timestamp]['name'] = $file['name'];
		$files[$timestamp]['link'] = $file['path'];
	}
}

krsort($files);
$i=0;
foreach($files as $timestamp => $f) {
	if ($i>$nitem)
		break;
	$name=$f['name'];
	$link=$f['link'];
	$rss.='	<item>
		<pubdate>'.date('r',$timestamp).'</pubdate>
		<title>'.$name.'</title>
		<link>'.$partage->make_download_url($link).'</link>
		<description><![CDATA[Fichier mis à jour le '.date('d-m-Y , H:i:s',$timestamp).']]></description>
		<guid>'.date('r',$timestamp).'</guid>
	</item>
';
	$i++;
}

$rss.='</channel>
</rss>';

$handle=fopen($includedir.'rss.xml','w');
fwrite($handle,$rss);
fclose($handle);

echo 'job is done';
?>
